#ifndef Tracker_APV_Eventreader_H
#define Tracker_APV_Eventreader_H

#include "ApvAnalysis.h"
#include "TkPedestalCalculator.h"
#include "TkNoiseCalculator.h"


class ApvEventReader {
  
 public:

  //
  // Who will call these? The Framework? The event loop?
  //

  virtual bool nextEvent() = 0 ;
  
  //
  // Since I will have only one reader for all the APVs, I need in 
  // the interface a way to read the event for the specific APV
  //
  
  virtual ApvAnalysis::RawSignalType rawSignal(ApvAnalysis& in) = 0;


};

#endif
