#ifndef ReferenceNoiseCalculator_H
#define ReferenceNoiseCalculator_H

#include "TkNoiseCalculator.h"

class ReferenceNoiseCalculator : public TkNoiseCalculator {
  
 public:  
  
  ReferenceNoiseCalculator(int tobedone) {
    eventsToBeDone=tobedone; 
    numberOfEvents=0; 
    theStatus.setCalibrating();
  }
  
  virtual void setStripNoise(NoiseType in) {theNoise = in;}
  virtual NoiseType stripNoise() const {return theNoise;}
  virtual float stripNoise(int in) const {return theNoise[in];}
  
  virtual void updateStatus();
  
  virtual void resetNoise() {theNoise.clear();}
  
  
  //Actions
  virtual void updateNoise(ApvAnalysis::SubtractedSignalType);

  void newEvent();

 protected:
  NoiseType theNoise;
  int numberOfEvents;
  int eventsToBeDone;
  bool alreadyUsedEvent;

};

#endif
