#ifndef ApvAnalysis_TT6APVAnalysis_h
#define ApvAnalysis_TT6APVAnalysis_h

#include "ApvAnalysis.h"

class TT6PedestalCalculator;
class TT6ApvAnalysis : public ApvAnalysis {
public:
  TT6ApvAnalysis();
  ~TT6ApvAnalysis();

  RawSignalType rawSignal();
  SubtractedSignalType pedestalSubtractedSignal();
  SubtractedSignalType CMPSubtractedSignal();
  ZeroSuppressedSignalType zeroSuppressedSignal(); 
  
//  void storePedestals() ;
//  void loadPedestals() ;
  
//  void storeNoise() ;
//  void loadNoise() ;
//  void load(RawSignalType& in){} 
  

  void newEvent();
  void updateCalibration();
  void setParameters(int nEventForInitialization, int nEventForUpdate);
  bool isCalibrated();

private:
  SubtractedSignalType theSubtractedData;
  int nEvents;
  int nEventForInitialization ;
  int nEventForUpdate;
  bool initialized;
  bool theRawsignalFlag;
  bool thePedSubSignalFlag;
  ApvAnalysis::RawSignalType theRawSignal;
  ApvAnalysis::SubtractedSignalType thePedSubSignal;
};
#endif
