#ifndef Tracker_TT6CommonModeCalculator_h
#define Tracker_TT6CommonModeCalculator_h

#include "TkCommonModeCalculator.h"
#include "TkNoiseCalculator.h"
#include "TkApvMask.h"

class TT6CommonModeCalculator : public TkCommonModeCalculator {
public:  
    
  TT6CommonModeCalculator(TkNoiseCalculator* noise_calc,
                          TkApvMask* mask_calc, float sig_cut);
  ~TT6CommonModeCalculator();

  ApvAnalysis::SubtractedSignalType doIt(ApvAnalysis::SubtractedSignalType ); 
  
  void setCM(TkCommonMode* in) {theTkCommonMode = in;}
  void setCM(vector<float> in) {theTkCommonMode->setCommonMode(in);}
  TkCommonMode* commonMode() {return theTkCommonMode;}

  void newEvent();
  
protected:
  
  void calculateCommonMode(ApvAnalysis::SubtractedSignalType& );
  void calculateTruncatedCommonMode(ApvAnalysis::SubtractedSignalType& );
  
  TkCommonMode*        theTkCommonMode;
  vector<float>        theCommonModeValues;
  TkNoiseCalculator*   theNoiseCalculator;
  TkApvMask*           theApvMask;
  float cutToAvoidSignal;
  bool alreadyUsedEvent;
}; 
#endif




