#ifndef ApvAnalysis_TT6PedestalCalculator_h
#define ApvAnalysis_TT6PedestalCalculator_h

#include "TkPedestalCalculator.h"
#include<map>

class TT6PedestalCalculator: public TkPedestalCalculator {
public: 

  TT6PedestalCalculator(int evnt_ini, int evnt_iter, float sig_cut);
  ~TT6PedestalCalculator();

  PedestalType pedestal() const {return thePedestal;};


  void resetPedestals() {thePedestal.clear();} 
  void setPedestals (PedestalType in) {thePedestal=in;}
    
  void updateStatus();

  ApvAnalysis::SubtractedSignalType doIt(ApvAnalysis::RawSignalType in);
  
  void updatePedestal (ApvAnalysis::RawSignalType in);

  void initializePedestal (ApvAnalysis::RawSignalType in);

  ApvAnalysis::SubtractedSignalType rawNoise() {return theRawNoise;}

  void newEvent();

protected:
  map <unsigned short, ApvAnalysis::RawSignalType> theRawSignalEventStrip;
  PedestalType thePedestal,thePedSum,thePedSqSum;
  PedestalType theRawNoise;  
  vector<unsigned short> theEventPerStrip;
  int  eventsForInitialization,eventsForIteration;
  float cutToAvoidSignal;
  int numberOfEvents;
  bool alreadyUsedEvent;
};
#endif
