#ifndef Tracker_TkPedestalCalculator_h
#define Tracker_TkPedestalCalculator_h

#include "ApvAnalysis.h"
#include "TkStateMachine.h"

class TkPedestalCalculator{
 public:
  
  typedef ApvAnalysis::SubtractedSignalType PedestalType;
  
  virtual PedestalType pedestal() const = 0 ;
  
  TkStateMachine* status() {return &theStatus;}
  
  virtual void resetPedestals() = 0;
  virtual void setPedestals (PedestalType) = 0;
  
  virtual void updateStatus() = 0 ;
  
  //
  // Actions
  //
  
  virtual ApvAnalysis::SubtractedSignalType doIt(ApvAnalysis::RawSignalType in) = 0;
  
  virtual void updatePedestal (ApvAnalysis::RawSignalType in) = 0 ;

  virtual ApvAnalysis::SubtractedSignalType rawNoise() {return ApvAnalysis::SubtractedSignalType();}

  virtual void newEvent(){}
  
 protected:
  
  TkStateMachine theStatus;
  
};

#endif
