#include "ReferenceClusterZeroSuppresser.h"
#include "TkNoiseCalculator.h"
#include "TkApvMask.h"


ApvAnalysis::ZeroSuppressedSignalType ReferenceClusterZeroSuppresser::doIt(ApvAnalysis::SubtractedSignalType ss, TkNoiseCalculator& ns, TkApvMask& mask){
  //
  // I am not really going to do it, I use a simple cut S/N>5 is isolated or S/N>2 if not (S and N based on strips!)
  //

  ApvAnalysis::ZeroSuppressedSignalType temp;
  
  ApvAnalysis::SubtractedSignalType tempss = mask.maskRawSignal(ss);

  for (int i=0; i<ss.size(); i++){
    if (tempss[i] > 2. * ns.stripNoise(i)){
      //look for cluster
      if ((i+1<ss.size() && (tempss[i+1] > 2. * ns.stripNoise(i+1)))||
	  (i-1>=0 && (tempss[i-1] > 2. * ns.stripNoise(i-1))) || 
	  (tempss[i] > 5. * ns.stripNoise(i)) ||
	  //
	  // if the firt or last strip of the apv, 2 sigmas is enough... 
	  // it will be discarded by the offline clusterizer if needed
	  //
	  (i==0) || (i==(ss.size()-1))  )
	temp.push_back(pair <short,float>(i,tempss[i]));
    }
  }
  return temp;
}
