#include <cmath>
#include "ReferenceNoiseCalculatorWithSignalRejection.h"


void ReferenceNoiseCalculatorWithSignalRejection::updateNoise(ApvAnalysis::SubtractedSignalType in){
  if(theStatus.isCalibrating() || theStatus.isUpdating()){
    if (theNoise.size() ==0) for (int i=0; i<in.size(); i++)theNoise.push_back(0.);
    if(alreadyUsedEvent == false){
      alreadyUsedEvent = true;
      NoiseType temp;
      int oldNumberOfEvents = numberOfEvents;
      numberOfEvents++;
      for (int i=0;i<theNoise.size();i++){
	if (fabs(theNoise[i]-in[i]) < 15 || numberOfEvents<30 ){
	  temp.push_back(((theNoise[i]*theNoise[i]*oldNumberOfEvents+(in[i])*(in[i]))/numberOfEvents));
	  theNoise[i] = sqrt(temp[i]);
	}else{
	  temp.push_back(0.);
	}
      }
    }
    updateStatus();
  }
}
