#ifndef VIEWER_ConfigXMLInfo
#define VIEWER_ConfigXMLInfo

#include "TGFrame.h"
#include "TGButton.h"
#include "TGLabel.h"
#include "TGTextEntry.h"
#include "TGNumberEntry.h"
#include <string>

enum EConfigXMLInfo {
  TB_BROWSE_RFILE,
  
  NE_ID_MOD,

  TE_ROOT_FILE,
  TE_OPR_NAME,

  RB_DEF_CUT,
  RB_SEL_CUT, 

  TB_DEF_ALL,
  TB_CLEAR_ALL,
  TB_CANCEL_CONF,
  TB_EXIT_CONF
};
class ConfigXMLInfo : public TGTransientFrame {

public:
   ConfigXMLInfo(const TGWindow* main, UInt_t w, UInt_t h, 
                int* idmod, int* icut,
                UInt_t options = 0, 
                ULong_t back = fgDefaultFrameBackground);
   ~ConfigXMLInfo();
   void       CreateDisplay();
   Bool_t     ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2);
  
   void       readAndSetValues();
   void       setDefaultValues();
   void       clearValues();
   void       selectRootFile();
      
private:
   const TGWindow*  fParent;

   TGLabel*           fIDModuleLab;
   TGNumberEntry*     fIDModuleNE;
   TGHorizontalFrame* fIDModuleFrame;

   TGLabel*           fRootFileLab;
   TGTextEntry*       fRootFileEntry;   
   TGTextButton*      fRootFileBut;
   TGHorizontalFrame* fRootFileFrame;

   TGLabel*           fBadChanDefLab;
   TGRadioButton*     fBadChanDefRB[2];
   TGHorizontalFrame* fBadChanDefFrame;

   TGLabel*           fOperatorLab;
   TGTextEntry*       fOperatorEntry;   
   TGHorizontalFrame* fOperatorFrame;

   TGTextButton*      fDefaultButton;
   TGTextButton*      fClearButton;
   TGTextButton*      fCancelButton; 
   TGTextButton*      fSetExitButton;
   TGHorizontalFrame* fButtonFrame;
   
   TGLayoutHints*     fL;
   TGLayoutHints*     fLBut;
         
   int*              fIDModule;
   int*              fCutFlag;

   string            fRootFileName;
   string            fOperatorName;
};

#endif
