//
//  This Window is used to configure Infor for XML File
//
#include <iostream.h>
#include <string>

#include "TROOT.h"
#include "TSystem.h"
#include "TKey.h"
#include "TGFileDialog.h"
#include "TGMsgBox.h"

#include "ModuleTestApp.h"
#include "ConfigAutoRunInfo.h"
//
// Constructor  
//
ConfigAutoRunInfo::ConfigAutoRunInfo(const TGWindow *main, UInt_t w, UInt_t h, 
		       int* imode, int* itype, int* ihv,
                       UInt_t options, ULong_t back) 
             : TGTransientFrame(gClient->GetRoot(), main, w, h, options)
{
  fParent     = main;

  fAPVMode   = imode;
  fDataType  = itype;
  fHVOption  = ihv;

  CreateDisplay();
  MapSubwindows();
  Resize(GetDefaultSize());
  SetWindowName("Auto DAQ Startup Definition Window");
  SetIconName("Auto DAQ Startup Definition Window");

  MapWindow();
  fClient->WaitFor(this);
}
// 
// Destructor 
//
ConfigAutoRunInfo::~ConfigAutoRunInfo() 
{
   delete       fConfFileLab;
   delete       fConfFileEntry;   
   delete       fConfFileBut;
   delete       fConfFileFrame;

   delete       fAPVModeLab;
   delete       fAPVModeRB[0];
   delete       fAPVModeRB[1];
   delete       fAPVModeFrame;

   delete       fAPVInvertLab;
   delete       fAPVInvertRB[0];
   delete       fAPVInvertRB[1];
   delete       fAPVInvertFrame;

   delete       fDataTypeLab;
   delete       fDataTypeRB[0];
   delete       fDataTypeRB[1];
   delete       fDataTypeFrame;

   delete       fHVOptionLab;
   delete       fHVOptionRB[0];
   delete       fHVOptionRB[1];
   delete       fHVOptionFrame;

   delete       fRootFileSaveLab;
   delete       fRootFileSaveEntry;   
   delete       fRootFileSaveFrame;

   delete       fDefaultButton;
   delete       fClearButton;
   delete       fCancelButton; 
   delete       fSetExitButton;
   delete       fButtonFrame;
   
   delete       fL;
   delete       fLBut;
}
void ConfigAutoRunInfo::CreateDisplay() 
{
  fL = new TGLayoutHints(kLHintsTop|kLHintsLeft, 5, 5, 5, 5);
  fLBut = new TGLayoutHints(kLHintsTop, 20, 20, 20, 20);

  // Configuration File Name
  fConfFileFrame =  new TGHorizontalFrame(this, 100, 30);
  AddFrame(fConfFileFrame);

  fConfFileLab = new TGLabel(fConfFileFrame, " Configuration File Name : ");
  fConfFileFrame->AddFrame(fConfFileLab, fL);
 
  fConfFileEntry = new TGTextEntry(fConfFileFrame, " ", TE_CONF_FILE);
  fConfFileFrame->AddFrame(fConfFileEntry, fL);
  fConfFileEntry->Resize(150, 25);
  fConfFileEntry->Associate(this);

  fConfFileBut = new TGTextButton(fConfFileFrame,"&Browse",TB_AUTO_BROWS_CFILE);
  fConfFileBut->Associate(this);
  fConfFileBut->SetToolTipText("Browse Files");
  fConfFileFrame->AddFrame(fConfFileBut,fL);
  // Select APV Mode
  fAPVModeFrame =  new TGHorizontalFrame(this, 100, 30);
  AddFrame(fAPVModeFrame);

  fAPVModeLab = new TGLabel(fAPVModeFrame, " APV Mode:     ");
  fAPVModeFrame->AddFrame(fAPVModeLab, fL);  

  fAPVModeRB[0] = new TGRadioButton(fAPVModeFrame, 
			     new TGHotString(" Peak      "),RB_PEAK_MODE);  
  fAPVModeRB[1] = new TGRadioButton(fAPVModeFrame, 
			 new TGHotString(" Deconvolution "),RB_DECO_MODE);
  for (int k = 0; k < 2; k++) { 
    fAPVModeRB[k]->Associate(this);
    fAPVModeFrame->AddFrame(fAPVModeRB[k], fL);
  }
  fAPVModeRB[0]->SetState(kButtonDown);
  // Select APV Invertion Option
  fAPVInvertFrame =  new TGHorizontalFrame(this, 100, 30);
  AddFrame(fAPVInvertFrame);

  fAPVInvertLab = new TGLabel(fAPVInvertFrame, " APV Inverter:  ");
  fAPVInvertFrame->AddFrame(fAPVInvertLab, fL);  

  fAPVInvertRB[0] = new TGRadioButton(fAPVInvertFrame, 
			     new TGHotString(" OFF       "),RB_INVERT_OFF);  
  fAPVInvertRB[1] = new TGRadioButton(fAPVInvertFrame, 
			 new TGHotString(" ON   "),RB_INVERT_ON);
  for (int k = 0; k < 2; k++) { 
    fAPVInvertRB[k]->Associate(this);
    fAPVInvertFrame->AddFrame(fAPVInvertRB[k], fL);
  }
  fAPVInvertRB[1]->SetState(kButtonDown);
  // Select Data Type 
  fDataTypeFrame =  new TGHorizontalFrame(this, 100, 30);
  AddFrame(fDataTypeFrame);

  fDataTypeLab = new TGLabel(fDataTypeFrame, " Data Type:      ");
  fDataTypeFrame->AddFrame(fDataTypeLab, fL);  

  fDataTypeRB[0] = new TGRadioButton(fDataTypeFrame, 
			   new TGHotString(" Pedestal "),RB_PEDS_TYPE);  
  fDataTypeRB[1] = new TGRadioButton(fDataTypeFrame, 
			 new TGHotString(" Calibration "),RB_CALB_TYPE);
  for (int k = 0; k < 2; k++) { 
    fDataTypeRB[k]->Associate(this);
    fDataTypeFrame->AddFrame(fDataTypeRB[k], fL);
  }
  fDataTypeRB[0]->SetState(kButtonDown);
  // Select HV Option (ON/OFF) 
  fHVOptionFrame =  new TGHorizontalFrame(this, 100, 30);
  AddFrame(fHVOptionFrame);

  fHVOptionLab = new TGLabel(fHVOptionFrame, " Power Option:  ");
  fHVOptionFrame->AddFrame(fHVOptionLab, fL);  

  fHVOptionRB[0] = new TGRadioButton(fHVOptionFrame, 
			   new TGHotString(" HV OFF "),RB_HV_OFF);  
  fHVOptionRB[1] = new TGRadioButton(fHVOptionFrame, 
			 new TGHotString(" HV ON "),RB_HV_ON);
  for (int k = 0; k < 2; k++) { 
    fHVOptionRB[k]->Associate(this);
    fHVOptionFrame->AddFrame(fHVOptionRB[k], fL);
  }
  fHVOptionRB[0]->SetState(kButtonDown);
  // Storage of Histogram in Root File Name
  fRootFileSaveFrame =  new TGHorizontalFrame(this, 100, 30);
  AddFrame(fRootFileSaveFrame);

  fRootFileSaveLab = new TGLabel(fRootFileSaveFrame, " Root File to Store: ");
  fRootFileSaveFrame->AddFrame(fRootFileSaveLab, fL);
 
  fRootFileSaveEntry = new TGTextEntry(fRootFileSaveFrame, " ", TE_CONF_FILE);
  fRootFileSaveFrame->AddFrame(fRootFileSaveEntry, fL);
  fRootFileSaveEntry->Resize(150, 25);
  fRootFileSaveEntry->Associate(this);

  /* Buttons for different Actions */
  fButtonFrame =  new TGHorizontalFrame(this, 450, 30);
  AddFrame(fButtonFrame);  
  
  fDefaultButton = new TGTextButton(fButtonFrame, "&Default",TB_AUTO_DEF);
  fDefaultButton->Resize(100,20);
  fDefaultButton->Associate(this);
  fDefaultButton->SetToolTipText("Set Default Values");
  fButtonFrame->AddFrame(fDefaultButton, fLBut);  

  fClearButton = new TGTextButton(fButtonFrame, "&Clear",TB_AUTO_CLEAR);
  fClearButton->Resize(100,20);
  fClearButton->Associate(this);
  fClearButton->SetToolTipText("Clear All Values");
  fButtonFrame->AddFrame(fClearButton, fLBut);  
  
  fCancelButton = new TGTextButton(fButtonFrame, "&Cancel",TB_AUTO_CANCEL);
  fCancelButton->Resize(100,20);
  fCancelButton->Associate(this);
  fCancelButton->SetToolTipText("Cancel Action");
  fButtonFrame->AddFrame(fCancelButton, fLBut);  

  fSetExitButton = new TGTextButton(fButtonFrame, "&Set and Exit",TB_AUTO_EXIT);
  fSetExitButton->Resize(300,20);
  fSetExitButton->Associate(this);
  fSetExitButton->SetToolTipText("Set Values and Exit");
  fButtonFrame->AddFrame(fSetExitButton, fLBut);  


  setDefaultValues();
}

// 
// Handle user actions 
//
Bool_t ConfigAutoRunInfo::ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2) 
{
    // Handle messages
  switch (GET_MSG(msg)) {

    case kC_COMMAND:
      switch (GET_SUBMSG(msg)) {

        case kCM_RADIOBUTTON:
          switch (parm1) {

          case RB_PEAK_MODE:
            {
              fAPVModeRB[1]->SetState(kButtonUp);
              break;
            }

          case RB_DECO_MODE:
            {
              fAPVModeRB[0]->SetState(kButtonUp);
              break;
            }

	   case RB_INVERT_OFF:
            {
              fAPVInvertRB[1]->SetState(kButtonUp);
              break;
            }

          case RB_INVERT_ON:
            {
              fAPVInvertRB[0]->SetState(kButtonUp);
              break;
            }
          case RB_PEDS_TYPE:
            {
              fDataTypeRB[1]->SetState(kButtonUp);
              break;
            }

          case RB_CALB_TYPE:
            {
              fDataTypeRB[0]->SetState(kButtonUp);
              break;
            }

          case RB_HV_OFF:
            {
              fHVOptionRB[1]->SetState(kButtonUp);
              break;
            }

          case RB_HV_ON:
            {
              fHVOptionRB[0]->SetState(kButtonUp);
              break;
            }

	  default:
	  break;
          
          }
        case kCM_BUTTON:
          switch (parm1) {
        
           case TB_AUTO_DEF:
             setDefaultValues();
             break;
 
           case TB_AUTO_CLEAR:
             clearValues();
             break;

           case TB_AUTO_CANCEL:
	     cancelAction();
             delete this;
             break;

           case TB_AUTO_EXIT:
             readAndSetValues();
             delete this;
             break;

	  case TB_AUTO_BROWS_CFILE:
            selectConfigurationFile();
            break;

            default:
            break;
          }
      }
   }
   return kTRUE;
}
// Set Default Values
void  ConfigAutoRunInfo::setDefaultValues() {
}
// Read and Set Values 
void  ConfigAutoRunInfo::readAndSetValues() {
  // Configuration File Name
  fConfFileName = fConfFileEntry->GetText();
  // Peak or  Deconvolution Mode
  int iDeconv;
  if (fAPVModeRB[0]->GetState() == kButtonDown) iDeconv = 0; // peak
  else if (fAPVModeRB[1]->GetState() == kButtonDown) iDeconv = 1;// deconv
  // Invertion On or Off
  int iInvert;
  if (fAPVInvertRB[0]->GetState() == kButtonDown) iInvert = 0; 
  else if (fAPVInvertRB[1]->GetState() == kButtonDown) iInvert = 1; 
  // Pedestal or Calibration Data Type
  if (fDataTypeRB[0]->GetState() == kButtonDown) *fDataType = 0;
  else if (fDataTypeRB[1]->GetState() == kButtonDown) *fDataType = 1;
  // HV Option
  if (fHVOptionRB[0]->GetState() == kButtonDown) *fHVOption = 0;
  else if (fHVOptionRB[1]->GetState() == kButtonDown) *fHVOption = 1;
  // Root File to Save Histogram
  fRootFileSaveName = fRootFileSaveEntry->GetDisplayText().Chop();
  // Define APV Mode 
  int iMode = 1;                     // (Bias ON [bit 0])
  if (iInvert == 1)    iMode += 32;  // (Inverter ON [bit 5])
  if (*fDataType == 0) iMode += 4 ;  // (Calibration OFF [bit 2])
  if (iDeconv == 0)    iMode += 10;  // Peak (bit 3) + 1 Sample (bit 1)
  *fAPVMode = iMode;
  cout << " Configuration File Name " << fConfFileName
       << " APV Mode " << *fAPVMode 
       << " Data Type " << *fDataType 
       << " HV Opton " << *fHVOption 
       << " Root File to Save Data " 
       << fRootFileSaveName << endl;
  ((ModuleTestApp*) fParent)->setRunConfigFile(fConfFileName);
  ((ModuleTestApp*) fParent)->setSaveRootFile(fRootFileSaveName);  
}  
// Clear Values 
void  ConfigAutoRunInfo::clearValues() {
  fConfFileEntry->SetText("");
  fRootFileSaveEntry->SetText("");
}
// Select Configuration File
void  ConfigAutoRunInfo::selectConfigurationFile() {
  TGFileInfo fi; 
  const char *fConfFileTypes[] = {"XML Files",    "*.xml"};
  fi.fFileTypes = fConfFileTypes;
  new TGFileDialog(fClient->GetRoot(), this, kFDOpen, &fi);
  if (!fi.fFilename) {
    int retval;
    new TGMsgBox(fClient->GetRoot(), this, "AUtomatic Run Message",
    "Configuration File with does not exist !!",
     kMBIconExclamation, kMBApply, &retval);  
    return;
  } else {
    fConfFileEntry->SetText(fi.fFilename);
  }  
}
//
// -- Cancel Action
//
void ConfigAutoRunInfo::cancelAction() {
  *fAPVMode   = -1;
  *fDataType  = -1;
  *fHVOption  = -1;
}
