//
//  A Labeled Entry 
//
#include "TGLabeledEntry.h" 

TGLabeledEntry::TGLabeledEntry(const TGWindow *parent, const char* label,
                const UInt_t w, const UInt_t h, const UInt_t gap, 
                UInt_t options, ULong_t back)
               :TGCompositeFrame(parent, w, h, options, back)
{
  //
  // Constructor  
  //

  fLabel = new TGLabel(this, new TGHotString(label));
  fL1    = new TGLayoutHints(kLHintsLeft,5,5,0,0);

  AddFrame(fLabel, fL1);

  fEntry = new TGTextEntry(this, fBuffer = new TGTextBuffer(25));
  fEntry->Resize(int(0.5*w), h);
  fL2    = new TGLayoutHints(kLHintsNormal, gap, 5, 0, 0);
  AddFrame(fEntry, fL2);
}

TGLabeledEntry::~TGLabeledEntry() 
{
  //
  // Destructor 
  //
  delete fLabel;
  //  We do not need to "delete fBuffer"
  delete fEntry;
  delete fL1;
  delete fL2;
}

//
// Set Value to the Entrybox
//
void TGLabeledEntry::SetText(const char *text) 
{
  fEntry->SetText(text);
}
//
// Get Value from the Entrybox
//
const char *TGLabeledEntry::GetText() 
{
  return fEntry->GetText();
}
//
// Get the TGTextEntry
//
TGTextEntry* TGLabeledEntry::getTGTextEntry() 
{
  return fEntry;
}
