void plot_calibration_charge(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameCal[15];
  int ich;
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    gStyle->SetOptStat(0); // no statistics
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          ich = idchip-1;
        } else {
          ich = i;
        }
        sprintf(hName, "channel_%i_strip_00",ich);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          fTh1->GetXaxis()->SetLabelSize(0.06);
          fTh1->GetYaxis()->SetLabelSize(0.06);
          sprintf(hTitle, " Calibration Charge for APV #%i",idchip);
          fTh1->SetNameTitle(hTitle, hTitle);
          fTh1->SetMaximum(100.0);
          fTh1->Draw();
          for (int k = 1; k < 128; k++) {
            if (k<10)
              sprintf(hName, "channel_%i_strip_0%i",ich,k);
            else
              sprintf(hName, "channel_%i_strip_%i",ich,k);
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);
            fTh1i->Draw("same");
          }
        }
      }
    } 
  }
}  
