void plot_calibration_charge_tt6(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameCal[15];
  int ich;
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    gStyle->SetOptStat(0); // no statistics
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          ich = idchip;
        } else {
          ich = i+1;
        }
        sprintf(hName, "APV_%i_Strip_01",ich);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          fTh1->GetXaxis()->SetLabelSize(0.07);
          fTh1->GetYaxis()->SetLabelSize(0.07);
	  sprintf(hTitle, " Calibration Charge for APV #%i",ich);
          fTh1->SetNameTitle(hTitle, hTitle);
          fTh1->SetMaximum(5.0);
          fTh1->SetMinimum(-100.0);
          fTh1->Draw();
          for (int k = 2; k < 129; k++) {
            if (k<10)
              sprintf(hName, "APV_%i_Strip_0%i",ich,k);
            else
              sprintf(hName, "APV_%i_Strip_%i",ich,k);
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);
            fTh1i->Draw("same");
          }
        }
      }
    } 
  }
}  
