void plot_cm(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameCM[15];
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    gStyle->SetOptStat(1);
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          sprintf(hName, "cmn_%i",idchip-1);
          sprintf(hTitle, " Common Mode for APV #%i",idchip);
        } else {
          sprintf(hName, "cmn_%i",i);
          sprintf(hTitle, " Common Mode for APV #%i",i+1);
        }
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          fTh1->GetXaxis()->SetLabelSize(0.07);
          fTh1->GetYaxis()->SetLabelSize(0.07);
          fTh1->SetNameTitle(hTitle, hTitle);
          fTh1->Draw();
        }
      }
    } else {
      tc->cd(1);
      sprintf(hNameCM, " Common Mode"); 
      sprintf(hTitle, " Common Mode");
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameCM);
      if (fTempH) delete fTempH;
      TH1F* fThCM = new TH1F (hNameCM, hTitle, nchip, 0.5, nchip+0.5);
      for (int i = 0; i < nchip; i++) {
        sprintf(hName, "cmn_%i",i);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          fThCM->Fill(float(i+1), fTh1->GetMean());
        }
      }
      fThCM->Draw();      
    }
  }
}  
