void plot_cm_tt6(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameCM[15];
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    if (imod == -1) {
      gStyle->SetOptStat(1);
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          sprintf(hName, "APV_%i_cmode",idchip);
        } else {
          sprintf(hName, "APV_%i_cmode",i+1);
        }
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          fTh1->GetXaxis()->SetLabelSize(0.07);
          fTh1->GetYaxis()->SetLabelSize(0.07);
          fTh1->Draw();
        }
      }
    } else {
      gStyle->SetOptStat(0);
      tc->cd(1);
      sprintf(hNameCM, "Common Mode"); 
      sprintf(hTitle, "Common Mode");
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameCM);
      if (fTempH) delete fTempH;
      TH1F* fThCM = new TH1F (hNameCM, hTitle, nchip, 0.5, nchip+0.5);
      for (int i = 0; i < nchip; i++) {
        sprintf(hName, "APV_%i_cmode",i+1);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          fThCM->Fill(float(i+1), fTh1->GetMean());
        }
      }
      fThCM->Draw();      
    }
  }
}  
