void plot_laser_palse_vs_strip(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameMaxLasS[15];
  int ich;
  static const int nChan  = 128;
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    gStyle->SetOptStat(0); // no statistics
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          ich = idchip-1;
        } else {
          ich = i;
        }
        sprintf(hName, "channel_%i_strip_00",ich);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          sprintf(hTitle, " Laser Palse vs Strip :APV #%i",ich); 
          sprintf(hNameMaxLasS,"hMaxLasS%i",i);
          TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameMaxLasS);
          if (fTempH) delete fTempH;
        
          TH1F* hMaxLasS =  new TH1F(hNameMaxLasS, hTitle, nChan, 0.5, nChan+0.5);
          for (int k = 0; k < nChan; k++) {
            if (k<10)
              sprintf(hName, "channel_%i_strip_0%i",ich,k);
            else
              sprintf(hName, "channel_%i_strip_%i",ich,k);    
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);    
            hMaxLasS->Fill(float(k+1), fTh1i->GetMinimum());
          }
          hMaxLasS->GetXaxis()->SetLabelSize(0.05);
          hMaxLasS->GetYaxis()->SetLabelSize(0.05);
          hMaxLasS->Draw();
        }
      }
    } else {
      tc->cd(1);
      Int_t nStrips = nChan * nchip;
      sprintf(hTitle, " Laser Palse vs Strip"); 
      sprintf(hNameMaxLasS,"hMaxLasS");
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameMaxLasS);
      if (fTempH) delete fTempH;

      TH1F* hMaxLasS = new TH1F(hNameMaxLasS,hTitle,nStrips,0.5, nStrips+0.5);
      for (int i = 0; i < nchip; i++) {
        sprintf(hName, "channel_%i_strip_00",i);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          for (int k = 0; k < nChan; k++) {
            if (k<10)
              sprintf(hName, "channel_%i_strip_0%i",i,k);
            else
              sprintf(hName, "channel_%i_strip_%i",i,k);    
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);    
            hMaxLasS->Fill(float(k+1+i*nChan), fTh1i->GetMinimum());
          }
        }
      }
      hMaxLasS->GetXaxis()->SetLabelSize(0.05);
      hMaxLasS->GetYaxis()->SetLabelSize(0.05);
      hMaxLasS->Draw();     
    }
  }
}  
