void plot_max_charge_tt6(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameMaxChD[5];
  int ich;
  static const int nChan  = 128;
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          ich = idchip;
        } else {
          ich = i+1;
        }
        sprintf(hName, "APV_%i_Strip_01",ich);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          sprintf(hNameMaxChD,"hMaxChD%i",i);
          TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameMaxChD);
          if (fTempH) delete fTempH;
          sprintf(hTitle, " Maximum Charge for APV #%i",ich);      
          TH1F* hMaxChD =  new TH1F(hNameMaxChD, hTitle, 100, -150.0, 0.0);
          for (int k = 0; k < nChan; k++) {
            if (k<9)
              sprintf(hName, "APV_%i_Strip_0%i",ich,k+1);
            else
              sprintf(hName, "APV_%i_Strip_%i",ich,k+1);    
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);    
            hMaxChD->Fill(fTh1i->GetMinimum());
          }
        }
        hMaxChD->GetXaxis()->SetLabelSize(0.07);
        hMaxChD->GetYaxis()->SetLabelSize(0.07);
        hMaxChD->Draw();
      }
    } else {
      tc->cd(1);
      Int_t nStrips = nChan * nchip;
      sprintf(hTitle, " Maximum Charge"); 
      sprintf(hNameMaxChD,"hMaxChD"); 
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameMaxChD);
      if (fTempH) delete fTempH;
  
      TH1F* hMaxChD =  new TH1F(hNameMaxChD, hTitle, 100, -150.0, 0.0);
      for (int i = 0; i < nchip; i++) {
        sprintf(hName, "APV_%i_Strip_01",i+1);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          for (int k = 0; k < nChan; k++) {
            if (k<9)
              sprintf(hName, "APV_%i_Strip_0%i",i+1,k+1);
            else
              sprintf(hName, "APV_%i_Strip_%i",i+1,k+1);    
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);    
            hMaxChD->Fill(fTh1i->GetMinimum());
          }
        }
      }      
      hMaxChD->GetXaxis()->SetLabelSize(0.07);
      hMaxChD->GetYaxis()->SetLabelSize(0.07);
      hMaxChD->Draw();      
    }
  }
}  
