void plot_noise(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameNoiseD[10];;
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) {
    gStyle->SetOptStat(1);
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          sprintf(hName, "noise_%i",idchip-1);
          sprintf(hTitle, " Noise for APV #%i",idchip);
        } else {
          sprintf(hName, "noise_%i",i);
          sprintf(hTitle, " Noise for APV #%i",i+1);
        }
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          sprintf(hNameNoiseD,"hNoiseD%i",i);
          TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameNoiseD);
          if (fTempH) delete fTempH;
          Int_t nBin  = fTh1->GetNbinsX();
          TH1F* hNoiseD =  new TH1F(hNameNoiseD, hTitle, 100, 0.0, 5.0);
          for (int k = 1; k < nBin+1; k++) {
            hNoiseD->Fill(fTh1->GetBinError(k));
          }      
          hNoiseD->GetXaxis()->SetLabelSize(0.07);
          hNoiseD->GetYaxis()->SetLabelSize(0.07);
          hNoiseD->Draw();
	}
      }      
    } else {
      tc->cd(1);
      Int_t nStrips = 128 * nchip;
      sprintf(hNameNoiseD, "Noise");
      sprintf(hTitle, "Noise ");      
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameNoiseD);
      if (fTempH) delete fTempH;      
      TH1F* hNoiseD = new TH1F (hNameNoiseD, hTitle, 100, 0.0, 5.0);
      for (int i = 0; i < nchip; i++) {
        sprintf(hName, "noise_%i",i);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          Int_t nBin = fTh1->GetNbinsX();
          for (int k = 1; k < nBin+1; k++) {
            hNoiseD->Fill(fTh1->GetBinError(k));
          }
        }
      }
      hNoiseD->GetXaxis()->SetLabelSize(0.07);
      hNoiseD->GetYaxis()->SetLabelSize(0.07);
      hNoiseD->Draw();
    }
  }
}
