void plot_rawnoise(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameRNoiseD[10];;
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) {
    gStyle->SetOptStat(1);
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          sprintf(hName, "pedestal_%i",idchip-1);
          sprintf(hTitle, " Raw Noise for APV #%i",idchip);
        } else {
          sprintf(hName, "pedestal_%i",i);
          sprintf(hTitle, " Raw Noise for APV #%i",i+1);
        }
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          sprintf(hNameRNoiseD,"hRNoiseD%i",i);
          TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameRNoiseD);
          if (fTempH) delete fTempH;
          Int_t nBin  = fTh1->GetNbinsX();
          TH1F* hRNoiseD =  new TH1F(hNameRNoiseD, hTitle, 100, 0.0, 5.0);
          for (int k = 1; k < nBin+1; k++) {
            hRNoiseD->Fill(fTh1->GetBinError(k));
          }      
          hRNoiseD->GetXaxis()->SetLabelSize(0.07);
          hRNoiseD->GetYaxis()->SetLabelSize(0.07);
          hRNoiseD->Draw();
	}
      }      
    } else {
      tc->cd(1);
      Int_t nStrips = 128 * nchip;
      sprintf(hNameRNoiseD, "Raw Noise");
      sprintf(hTitle, "Raw Noise ");      
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameRNoiseD);
      if (fTempH) delete fTempH;      
      TH1F* hRNoiseD = new TH1F (hNameRNoiseD, hTitle, 100, 0.0, 5.0);
      for (int i = 0; i < nchip; i++) {
        sprintf(hName, "pedestal_%i",i);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          Int_t nBin = fTh1->GetNbinsX();
          for (int k = 1; k < nBin+1; k++) {
            hRNoiseD->Fill(fTh1->GetBinError(k));
          }
        }
      }
      hRNoiseD->GetXaxis()->SetLabelSize(0.07);
      hRNoiseD->GetYaxis()->SetLabelSize(0.07);
      hRNoiseD->Draw();
    }
  }
}
