void plot_rawnoise_vs_strip_tt6(int imod, int nchip, int idchip, const char* canvas_name) {

  char  hTitle[30], hNameRNoise[30], hNameRNoiseM[30];
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    gStyle->SetOptStat(0);
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          sprintf(hNameRNoise, "APV_%i_rnoise_vs_str",idchip);
        } else {
          sprintf(hNameRNoise, "APV_%i_rnoise_vs_str",i+1);
        }
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hNameRNoise);
        if (fTh1) {
          fTh1->GetXaxis()->SetLabelSize(0.07);
          fTh1->GetYaxis()->SetLabelSize(0.07);
          fTh1->SetMinimum(0.0);
          fTh1->SetMaximum(5.0);

          fTh1->Draw();
        }
      }
    } else {
      tc->cd(1);
      Int_t nStrips = 128 * nchip;
      sprintf(hNameRNoiseM, "RawNoise_vs_Strip");
      sprintf(hTitle, "Raw Noise Vs Strip");      
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameRNoiseM);
      if (fTempH) delete fTempH;      
      TH1F* fThRNoise = new TH1F (hNameRNoiseM, hTitle, nStrips,
                               0.5,  nStrips+0.5);
      for (int i = 0; i < nchip; i++) {
        sprintf(hNameRNoise, "APV_%i_rnoise_vs_str",i+1);        
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hNameRNoise);
        if (fTh1) {
          Int_t nBin = fTh1->GetNbinsX();
          for (int k = 1; k < nBin+1; k++) {
            fThRNoise->Fill((k+(i*128.0)), fTh1->GetBinContent(k));
          }
        }
      }
      fThRNoise->GetXaxis()->SetLabelSize(0.05);
      fThRNoise->GetYaxis()->SetLabelSize(0.05);
      fThRNoise->Draw();      
    } 
  }
}
