void plot_tau(int imod, int nchip, int idchip, const char* canvas_name) {
  char  hName[30], hTitle[30], hNameTauD[15];
  int ich;
  static const int nChan  = 128;
  TCanvas * tc = (TCanvas *) gROOT->FindObject(canvas_name);
  if (tc) { 
    gStyle->SetOptStat(1); // no statistics
    if (imod == -1) {
      for (int i = 0; i < nchip; i++) {
        tc->cd(i+1);
        if (nchip == 1) {
          ich = idchip-1;
        } else {
          ich = i;
        }
        sprintf(hName, "channel_%i_strip_00",ich);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          sprintf(hNameTauD,"hTauD%i",i);
          TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameTauD);
          if (fTempH) delete fTempH;

          sprintf(hTitle, " Rise Time for APV #%i",ich+1);      
          TH1F* hTauD =  new TH1F(hNameTauD, hTitle, 100, 0.0, 150.0);
          for (int k = 0; k < nChan; k++) {
            if (k<10)
              sprintf(hName, "channel_%i_strip_0%i",ich,k);
            else
              sprintf(hName, "channel_%i_strip_%i",ich,k);    
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);    
            Int_t maxBin = fTh1i->GetMaximumBin();            
            float thrBin;   
            for (int j = 0; j < maxBin; j++){
              if (fTh1i->GetBinContent(j) < 3.0){
                thrBin = j; 
              } else {
                break;
              }
            } 
            float tau_val = (maxBin - thrBin)*3.125;
            hTauD->Fill(tau_val);
          }
          hTauD->GetXaxis()->SetLabelSize(0.05);
          hTauD->GetYaxis()->SetLabelSize(0.05);
          hTauD->Draw();
        }
      }
    } else { 
      tc->cd(1);
      Int_t nStrips = nChan * nchip;
      sprintf(hTitle, " Rise Time");  
      sprintf(hNameTauD,"hTauD");     
      TH1 *fTempH = (TH1 *) gROOT->FindObject(hNameTauD);
      if (fTempH) delete fTempH;

      TH1F* hTauD = new TH1F(hNameTauD, hTitle, 100, 0.0, 150.0);
      for (int i = 0; i < nchip; i++) {
        sprintf(hName, "channel_%i_strip_00",i);
        TH1 *fTh1 = (TH1 *) gROOT->FindObject(hName);
        if (fTh1) {
          for (int k = 0; k < nChan; k++) {
            if (k<10)
              sprintf(hName, "channel_%i_strip_0%i",i,k);
            else
              sprintf(hName, "channel_%i_strip_%i",i,k);    
            TH1 *fTh1i = (TH1 *) gROOT->FindObject(hName);    
            Int_t maxBin = fTh1i->GetMaximumBin();            
            float thrBin;   
            for (int j = 0; j < maxBin; j++){
              if (fTh1i->GetBinContent(j) < 3.0){
                thrBin = j; 
              } else {
                break;
              }
            } 
            float tau_val = (maxBin - thrBin)*3.125;
            hTauD->Fill(tau_val);
          }
        }
      }
      hTauD->GetXaxis()->SetLabelSize(0.05);
      hTauD->GetYaxis()->SetLabelSize(0.05);
      hTauD->Draw();
    }
  }
}  
